#!/bin/bash

package=essentia
version=-full-git

progname=$0

source ../cascade-make/lib/cascade-lib.bash GEXT_MARS ../.. $*

if [ "x$VIRTUAL_ENV" != "x" ] ; then
    prefix="$VIRTUAL_ENV"
else
    prefix="$GEXT_MARS_INSTALLED"
fi

opt_run_untar $force_untar $auto_untar $package $version

#opt_run_configure $force_config $auto_config $package $version $prefix 
# consider making a waf version for configure?
if [ $force_config = "1" ] ; then

    echo "[pushd $package$version]"
    ( cd $package$version ; \
      # Do full configure with testing (note: needs full recursive git cloned version of repository to provide models and sample audio files)
      echo ./waf configure --build-static --with-python --with-cpptests --with-examples --prefix="$prefix" $@ ; \
      eval ./waf configure --build-static --with-python --with-cpptests --with-examples --prefix="$prefix" $@ ; )
    if [ $? != 0 ] ; then
        echo "      Error encountered running *configure* stage of $progname"
        exit 1
    fi
    echo "[popd]"
fi

#opt_run_make $compile $package $version
# consider making a waf version for compiling?
# (and dropping the testing part)
if [ $compile = "1" ] ; then
    echo "[pushd $package$version]"
    ( cd $package$version ; \
      # Do full configure with testing (note: needs full recursive git cloned version of repository to provide models and sample audio files)
      echo "./waf && ./waf run_tests" ; \
      eval ./waf && ./waf run_tests )
    if [ $? != 0 ] ; then
        echo "      Error encountered running *compile* stage of $progname"
        exit 1
    fi
    echo "[popd]"

    # python3 ./waf run_python_tests
fi

#opt_run_make $install $package $version "install"
# consider making a waf version for install?
if [ $install = "1" ] ; then
    echo "[pushd $package$version]"
    ( cd $package$version ; \
      echo ./waf install ; \
      eval ./waf install )
    if [ $? != 0 ] ; then
        echo "      Error encountered running *install* stage of $progname"
        exit 1
    fi
    echo "[popd]"
fi


opt_run_make $clean $package $version "clean"
opt_run_make $distclean $package $version "distclean"

opt_run_tarclean $tarclean $package $version
